<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="hu"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AlienEntity.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Spaceinvaders app</a> &gt; <a href="index.source.html" class="el_package">default</a> &gt; <span class="el_source">AlienEntity.java</span></div><h1>AlienEntity.java</h1><pre class="source lang-java linenums">

/**
 * An entity which represents one of our space invader aliens.
 * 
 * @author Kevin Glass
 */
public class AlienEntity extends Entity {
	/** The speed at which the alient moves horizontally */
<span class="nc" id="L10">	private double moveSpeed = 75;</span>
	/** The game in which the entity exists */
	private Game game;
	
	/**
	 * Create a new alien entity
	 * 
	 * @param game The game in which this entity is being created
	 * @param ref The sprite which should be displayed for this alien
	 * @param x The intial x location of this alien
	 * @param y The intial y location of this alient
	 */
	public AlienEntity(Game game,String ref,int x,int y) {
<span class="nc" id="L23">		super(ref,x,y);</span>
		
<span class="nc" id="L25">		this.game = game;</span>
<span class="nc" id="L26">		dx = -moveSpeed;</span>
<span class="nc" id="L27">	}</span>

	/**
	 * Request that this alien moved based on time elapsed
	 * 
	 * @param delta The time that has elapsed since last move
	 */
	public void move(long delta) {
		// if we have reached the left hand side of the screen and
		// are moving left then request a logic update 
<span class="nc bnc" id="L37" title="All 4 branches missed.">		if ((dx &lt; 0) &amp;&amp; (x &lt; 10)) {</span>
<span class="nc" id="L38">			game.updateLogic();</span>
		}
		// and vice vesa, if we have reached the right hand side of 
		// the screen and are moving right, request a logic update
<span class="nc bnc" id="L42" title="All 4 branches missed.">		if ((dx &gt; 0) &amp;&amp; (x &gt; 750)) {</span>
<span class="nc" id="L43">			game.updateLogic();</span>
		}
		
		// proceed with normal move
<span class="nc" id="L47">		super.move(delta);</span>
<span class="nc" id="L48">	}</span>
	
	/**
	 * Update the game logic related to aliens
	 */
	public void doLogic() {
		// swap over horizontal movement and move down the
		// screen a bit
<span class="nc" id="L56">		dx = -dx;</span>
<span class="nc" id="L57">		y += 10;</span>
		
		// if we've reached the bottom of the screen then the player
		// dies
<span class="nc bnc" id="L61" title="All 2 branches missed.">		if (y &gt; 570) {</span>
<span class="nc" id="L62">			game.notifyDeath();</span>
		}
<span class="nc" id="L64">	}</span>
	
	/**
	 * Notification that this alien has collided with another entity
	 * 
	 * @param other The other entity
	 */
	public void collidedWith(Entity other) {
		// collisions with aliens are handled elsewhere
<span class="nc" id="L73">	}</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>